﻿601,100
602,"}tp_deploy_create_shadow_dimension"
562,"NULL"
586,
585,
564,
565,"oBAewiiy4yqs6pma41OHMrH5_VhUt3@c83>]wL@>7lTL[\@gp6Os3uxip6>bcJ@3ln[;]b1V]uiTH]3h6XY9nDdP7o@a<sagyDhy^`uO]_8:uFqOZ@sGI28?Ltrw80T7W>xc5sDXI9?iJ@sI;4mztC7VFbg3FRL6RD8CzrBUrc`NErVw]uv]6okCy]]g4zrE4tTWhXHZ"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,6
pExecutionId
pAppId
pApprovalDim
pApprovalSubset
pSubsetAlias
pIncrShadowDimUpdate
561,6
2
2
2
2
2
2
590,6
pExecutionId,"None"
pAppId,"MyApp"
pApprovalDim,"TestElist"
pApprovalSubset,"TestElist"
pSubsetAlias,"None"
pIncrShadowDimUpdate,"N"
637,6
pExecutionId,""
pAppId,""
pApprovalDim,""
pApprovalSubset,""
pSubsetAlias,""
pIncrShadowDimUpdate,""
577,0
578,0
579,0
580,0
581,0
582,0
931,1

603,0
572,121


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009, 2010, 2013
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


#*** Log File Name
cConfigDim = '}tp_config';
If (DimensionExists(cConfigDim) = 1);
	cGenerateLog = ATTRS(cConfigDim, 'Generate TI Log', 'String Value');
Else;
	cGenerateLog = 'N';
EndIf;

cTM1Process = GetProcessName();
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
StringGlobalVariable('gDataLog');

If (cGenerateLog @= 'Y' % cGenerateLog @= 'T');
	vReturnValue = ExecuteProcess('}tp_get_log_file_names', 'pExecutionId', pExecutionId,
		'pProcess', cTM1Process, 'pControl', 'Y');
	If (vReturnValue <> ProcessExitNormal());
		ProcessError;
	EndIf;
EndIf;

cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cDataLog = gDataLog;
cTM1Log = cPrologLog;

#*** Log Parameters

If (cGenerateLog @= 'Y');
	TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Parameters:',
	pExecutionId, pAppId, pApprovalDim, pApprovalSubset);
EndIf;


#*** Define constants
cShadowApprovalDim = '}tp_tasks}' | pAppId;
cAttributeCube = '}ElementAttributes_' | cShadowApprovalDim;
cAttributeDim = cAttributeCube;
cApprovalAttributeCube = '}ElementAttributes_' | pApprovalDim;
cApprovalAttributeDim = cApprovalAttributeCube;


#*** Create Shadow Dimension
If (pIncrShadowDimUpdate @= 'Y');
	vCopyApprovalHierarchyContents = 'N';
Else;
	vCopyApprovalHierarchyContents = 'Y';
EndIf;

If (DimensionExists(cShadowApprovalDim) = 0);
	DimensionCreate(cShadowApprovalDim);
	vCopyApprovalHierarchyContents = 'Y';
EndIf;

IF (SubsetExists(cShadowApprovalDim, pApprovalSubset) = 0);
	SubsetCreate(cShadowApprovalDim, pApprovalSubset);
EndIf;


#*** copy all aliases from approval dimension to the shadow dimension
vTotalAttributes = DIMSIZ(cApprovalAttributeDim);
vAttrLooper = vTotalAttributes;

While (vAttrLooper >=1);
	vAttribute = DIMNM(cApprovalAttributeDim, vAttrLooper);
	insertAlias = 'N';
	If (CubeExists(cAttributeCube) =0);
		insertAlias = 'Y';
	ElseIf (DIMIX(cAttributeDim, vAttribute) = 0);
		insertAlias = 'Y';
	Else;
		insertAlias = 'N';
	EndIf;
	
	IF (insertAlias @= 'Y');
		vAttributeType = DType(cApprovalAttributeDim, vAttribute);
		IF (vAttributeType @= 'AA');
			AttrInsert(cShadowApprovalDim, '', vAttribute, 'A');
		EndIf;
	EndIf;
	vAttrLooper = vAttrLooper -1;
End;


#*** Use the same alias
If (pSubsetAlias @<>'' & DIMIX(cAttributeDim, pSubsetAlias) >0);
	SubsetAliasSet(cShadowApprovalDim, pApprovalSubset, pSubsetAlias);
EndIf;


#*** Delete all elements in Shadow Approval Dimension and copy all elements from approval hierarchy
If (vCopyApprovalHierarchyContents @= 'Y');
	SubsetDeleteAllElements(cShadowApprovalDim, pApprovalSubset);
	DimensionDeleteAllElements(cShadowApprovalDim);

	vTotalNodes = SubsetGetSize(pApprovalDim, pApprovalSubset);
	looper = 1;
	While (looper <= vTotalNodes);
		vElem = SubsetGetElementName(pApprovalDim,  pApprovalSubset, looper);
		vType = DType(pApprovalDim, vElem);
		DimensionElementInsert(cShadowApprovalDim, '', vElem, vType);
		looper = looper +1;
	End;
EndIf;
573,1

574,1

575,61


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009, 2010, 2013
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


#*** Set parent and child relationship.
If (vCopyApprovalHierarchyContents @= 'Y');
	StringGlobalVariable('gTopNode');
	vReturnValue = ExecuteProcess('}tp_get_top_node', 'pExecutionId', pExecutionId,'pDim', pApprovalDim, 'pSubset', pApprovalSubset, 'pControl', 'Y');
	If (vReturnValue <> ProcessExitNormal());
		ProcessError;
	EndIf;
	SubsetElementInsert(cShadowApprovalDim, pApprovalSubset, gTopNode, 0);

	vTotalChildren = ELCOMPN(pApprovalDim, gTopNode);
	If (vTotalChildren >=1);
		vReturnValue = ExecuteProcess('}tp_deploy_shadow_dim_add_direct_children', 'pExecutionId', pExecutionId,'pAppId', pAppId,
			'pApprovalDim', pApprovalDim, 'pApprovalSubset', pApprovalSubset, 'pParent', gTopNode);
		If (vReturnValue <> ProcessExitNormal());
			ProcessError;
		EndIf;
	EndIf;
EndIf;


#*** Add alias for each node on shadow dimension
vTotalNodes = SubsetGetSize(pApprovalDim, pApprovalSubset);
looper = 1;
While (looper <=vTotalNodes);
	vElem = SubsetGetElementName(pApprovalDim,  pApprovalSubset, looper);

	vTotalAttributes = DIMSIZ(cApprovalAttributeDim);
	vAttrLooper = vTotalAttributes;

	While (vAttrLooper >=1);
		vAttribute = DIMNM(cApprovalAttributeDim, vAttrLooper);
		vAttributeType = DType(cApprovalAttributeDim, vAttribute);
		IF (vAttributeType @= 'AA');
			vApprovalElemAlias = AttrS(pApprovalDim, vElem, vAttribute);
			vShadowElemAlias = AttrS(cShadowApprovalDim, vElem, vAttribute);
			IF (vApprovalElemAlias @<> vShadowElemAlias);
				AttrPutS(vApprovalElemAlias, cShadowApprovalDim, vElem, vAttribute);
			EndIf;
		EndIf;
		vAttrLooper = vAttrLooper -1;
	End;
	looper = looper +1;
End;

576,
930,0
638,1
804,0
1217,0
900,
901,
902,
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
